<?php

/**
 * TorrentTrader v2.0 RC1
 *  - Coded by Sqrtboy (sqrtboy@phpsoft.org)
 *  - Released under the GPL licence
 *  - Support/Hacks/Discussion @ http://www.torrenttrader.com
 *  - Email: sqrtboy@phpsoft.org
 **/

if (!session_id())
session_start();

/* turn on/off global variables */
ini_set('register_globals', '0');

extract($GLOBALS);
extract($_SERVER);
extract($_GET);
extract($_POST);
extract($_COOKIE);
extract($_FILES);
extract($_ENV);
extract($_REQUEST);

/* core files */
require_once('admin/config.php');
require_once('classes/class.template.php');
require_once('classes/class.error.php');
require_once('classes/class.database.php');
require_once('classes/class.bbcode.php');
require_once('classes/class.timer.php');

/* execution time */
$timer->start_timer();

/* database connection */
$db->set_host($dbhost);
$db->set_database($dbname);
$db->set_username($dbuser);
$db->set_password($dbpass);
$db->connect();
$db->select_db();
$db->close();





/* gzip output */
if($gzip_enabled == 'YES')
	{
	include('classes/class.gzip.php');
	}



/* confirm member actually exists */
function tt_confirm_member($username, $password)
	{
	global $db,$dbprfx;
	/* add slashes if necessary (for query) */
	if(!get_magic_quotes_gpc())
		{
		$username = addslashes($username);
		}

	/* verify that user is in database */
	$fetch = $db->fetch_row("SELECT username, password FROM ".$dbprfx."members WHERE username = '$username' AND status='confirmed'");
	if($fetch[0] == '')
		{
		return 1;
		}

	/* validate that password is correct */
	if($password == $fetch[1])
		{
		return 0;
		}
   		else
   		{
		return 2;
		}
	}

/* check if member is logged in */
function tt_confirm_login()
	{
    global $db, $dbprfx ;
    
    // cleanup old torrents, members and peers every hour	
	if (!file_exists("cache/last_cleanup"))
		touch("cache/last_cleanup");
		
	$since_last_cleanup = @time() - @filemtime("cache/last_cleanup");
	
	if ($since_last_cleanup  > 3600)	
		{
		tt_cleanup();
		touch("cache/last_cleanup");
		}
		
	/* check if user has been remembered */
	if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
		{
		$_SESSION['username'] = $_COOKIE['cookname'];
		$_SESSION['password'] = $_COOKIE['cookpass'];
		}

	/* username and password have been set */
	if(isset($_SESSION['username']) && isset($_SESSION['password']))
		{
		/* confirm that username and password are valid */
		if(tt_confirm_member($_SESSION['username'], $_SESSION['password']) != 0)
			{
			/* variables are incorrect, user not logged in */
			unset($_SESSION['username']);
			unset($_SESSION['password']);
			return false;
			}
		$_SESSION['logged_in'] = true;
    	$db->query("UPDATE ".$dbprfx."members SET lastvisit=NOW() WHERE username='".$_SESSION['username']."'");
		return true;
		}
		/* user not logged in */
		else
		{
        $_SESSION['logged_in'] = false;
		return false;
		}

			
	}

$loggedin = tt_confirm_login();

function tt_guest_add() {
    global $db, $dbprfx ;
    $ip = getip();
	$num = $db->count_rows("SELECT time FROM ".$dbprfx."guests WHERE ip='$ip'");
    if ($num > 0)
	{
		$db->query("UPDATE ".$dbprfx."guests SET ip='$ip', time=NOW() WHERE ip='$ip'");
    } else {
		$db->query("INSERT INTO ".$dbprfx."guests (ip, time) VALUES ('$ip', NOW())");
    }
}

function tt_get_guests() {
    global $db, $dbprfx ;
    $ip = getip();
	$db->query("DELETE FROM ".$dbprfx."guests WHERE (NOW() - time) > 300");
	return $db->count_rows("SELECT * FROM ".$dbprfx."guests ");
}

/* get member details */
if($loggedin)
	{
	$CURUSER = $db->fetch_row('SELECT * FROM '.$dbprfx.'members WHERE username = "'.$_SESSION['username'].'" LIMIT 1');

	if (strlen($CURUSER['passkey']) != 32) {
    	$CURUSER['passkey'] = md5($CURUSER['username'].strtotime("now").$CURUSER['password']);
        $db->query("UPDATE ".$dbprfx."members SET passkey='".$CURUSER['passkey']."' WHERE username = '".$_SESSION['username']."'");
	}
    $theme = $db->fetch_row('SELECT * FROM '.$dbprfx.'themes WHERE id = "'.$CURUSER['theme'] .'" LIMIT 1');
    $tt_theme = $theme['file'];
	$_SESSION['passkey'] = $CURUSER['passkey'] ;
    }
else
{
tt_guest_add() ;
}

/* we preload all users informations sorted by id on each page load*/
$temp = $db->query('SELECT * FROM '.$dbprfx.'members ORDER BY id ASC');
while ($member = $db->fetch_array($temp))
{
$users[$member['id']] = array('username' => $member['username']
                             ,'groups'=> $member['groups']);
}



/* Prev/Next */
function tt_pager($limit, $page, $where = '')
	{
	global $db, $dbprfx;
	if($where)
		{
		$where = ' AND '.$where.'';
		}
	if ($limit=='')
    $limit=25;
	$total_results = $db->count_rows('SELECT id FROM '.$dbprfx.'torrents WHERE visible = "yes" AND banned = "no"'.$where.'');
	$total_pages = ceil($total_results / $limit);

    if ($total_results==0)
    return "";
    
	if (empty($page))
	    {
	        $page = "1";
	    }
	if ($page > $total_pages)
    $page = $total_pages;

	$offset = ($page - 1) * $limit;
	$output = ''.$total_pages.' pages listing '.$total_results.' releases<br />';
	if ($page != 1)
		{
		$output .= '<a href=?page=1><< First</a>&nbsp;&nbsp;&nbsp;';
		$prevpage = $page - 1;
		$output .= '&nbsp;<a href=?page='.$prevpage.'><<</a>&nbsp;';
		}

	if ($page == $total_pages)
	   	{
		$to = $total_pages;
		}
	elseif ($page == $total_pages-1)
		{
		$to = $page+1;
		}
	elseif ($page == $total_pages-2)
		{
		$to = $page+2;
		}
	else
		{
		$to = $page+3;
		}

	if ($page == 1 || $page == 2 || $page == 3)
		{
		$from = 1;
		}
		else
		{
		$from = $page-3;
		}

	for ($i = $from; $i <= $to; $i++)
		{
	    if ($i == $total_results) $to=$total_results;
	    if ($i != $page)
			{
	        $output .= '<a href=?page='.$i.'>'.$i.'</a>';
	        }
	    else
	        {
	        $output .= '['.$i.']';
	        }
	    if ($i != $total_pages)
	    	{
	        $output .= '&nbsp;';
	    	}
	    }

	if ($page != $total_pages)
		{
		$nextpage = $page + 1;
		$output .= '&nbsp;<a href=?page='.$nextpage.'>>></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href=?page='.$total_pages.'>Last >></a>';
		}
	return $output;
	}

function tt_ratingpic($num) {
    $r = round($num * 2) / 2;
    if ($r < 1 || $r > 5)
        return "-";
    return "<img src=\"images/$r.gif\" border=\"0\" alt=\"rating: $num / 5\" />";
}

/* list the torrents */
function tt_list_torrents($limit, $page, $sort, $order, $where = '')
	{
	global $db, $dbprfx, $CURUSER;
	/* TorrentTrader v1.0.0 Wait Hack by TheWatcher */
	$gigs = $CURUSER["uploaded"] / (1024*1024*1024);
	$ratio = (($CURUSER["downloaded"] > 0) ? ($CURUSER["uploaded"] / $CURUSER["downloaded"]) : 0);
	if ($ratio < 0.5 || $gigs < 5)
		{
		$wait = 48;
		}
		elseif ($ratio < 0.65 || $gigs < 6.5)
			{
			$wait = 24;
			}
		elseif ($ratio < 0.8 || $gigs < 8)
			{
			$wait = 12;
			}
		elseif ($ratio < 0.95 || $gigs < 9.5)
			{
			$wait = 6;
			}
		else
			{
			$wait = 0;
			}
	if($where)
		{
		$where = ' AND '.$where.'';
		}
	$total_results = $db->count_rows('SELECT id FROM '.$dbprfx.'torrents WHERE visible = "yes" AND banned = "no"'.$where.'');
    if ($limit=='')
    $limit = 25;
    $total_pages = ceil($total_results / $limit);
	if (empty($page))
	    {
	        $page = "1";
	    }
    if ($page > $total_pages)
    $page = $total_pages;

	$offset = ($page - 1) * $limit;
	if ($offset <0)  
		$offset = 0;
			
	$result = $db->query('SELECT * FROM '.$dbprfx.'torrents WHERE visible = "yes" AND banned = "no"'.$where.' ORDER BY '.$sort.' '.$order.' LIMIT '.$offset.', '.$limit.'');
    $torrentlist = array(); 
	while ($row = $db->fetch_array($result))
		{
		if ($wait)
			{
			/* TorrentTrader v1.0.0 Wait Hack by TheWatcher */
			$elapsed = floor((strtotime(gmdate("Y-m-d H:i:s")) - strtotime($row["added"])) / 3600);
	        if ($elapsed < $wait)
	       		{
	          	$color = dechex(floor(127*($wait - $elapsed)/48 + 128)*65536);
	          	$wait = number_format($wait - $elapsed);
	        	}
	        	else
	        	{
	          	$wait = 'none';
	          	}
        	}

    $subres = $db->query("SELECT to_go FROM ".$dbprfx."torrents_peers WHERE torrent = ".$row["id"]);

            $tmp=0;
            $prgs=0;
            $prgsf = 0;
            
            while ($subrow = $db->fetch_array($subres)) {
            	$tmp++;
	            $prgs+= 100 * (1 - ($subrow["to_go"] / $row["size"]));
			}
            if ($tmp!=0)
            $prgsf=floor($prgs / $tmp);

	        if ($prgsf>=0 && $prgsf <20) $progress='<img src="images/progress-0.gif"> (<b>'.(int)$prgsf.'%</b>)';
	        else if ($prgsf>=20 && $prgsf <40) $progress='<img src="images/progress-1.gif"> (<b>'.(int)$prgsf.'%</b>)';
	        else if ($prgsf>=40 && $prgsf <60) $progress='<img src="images/progress-2.gif"> (<b>'.(int)$prgsf.'%</b>)';
	        else if ($prgsf>=60 && $prgsf <80) $progress='<img src="images/progress-3.gif"> (<b>'.(int)$prgsf.'%</b>)';
	        else if ($prgsf>=80 && $prgsf <100) $progress='<img src="images/progress-4.gif"> (<b>'.(int)$prgsf.'%</b>)';
	        else if ($prgsf>=100 ) $progress='<img src="images/progress-5.gif"> (<b>'.(int)$prgsf.'%</b>)';
    	if ($row['numratings'])
        $row["rating"] = floor($row['ratingsum'] /  $row['numratings']);
        else
        $row["rating"] = 0 ;

		$rating = tt_ratingpic($row["rating"]);

		$torrentlist[] = array(
		'id' => $row['id'],
        'color'=> color_torrent($row['seeders'],$row['leechers']),
		'category' => tt_get_category($row['category']),
		'categoryid' => $row['category'],
		'name' => tt_shorten($row['name'], 45),
		'wait' => $wait,
		'files' => $row['files'],
		'comments' => $row['comments'],
		'rating' => $rating,
		'added' => $row['added'],
		'size' => tt_filesize($row['size']),
		'views' => $row['views'],
		'hits' => $row['hits'],
        'lang' => $row['lang'],
        'group' => $row['group'],
		'completed' => $row['completed'],
		'seeders' => $row['seeders'],
		'leechers' => $row['leechers'],
        'ulspeed' => tt_filesize($row['ulspeed'])."/s",
        'dlspeed' => tt_filesize($row['dlspeed'])."/s",
        'progress' => $progress,
		'owner' => tt_get_username($row['owner']),
		'ownerid' => $row['owner'],
		);
		}


	return $torrentlist;
	}
/* torrent color */
function color_torrent($seeders,$leechers)
{
$ratio = ($leechers > 0) ? ($seeders / $leechers) : 0;
	if ($ratio < 0.5 )
		{
		$color= "#ffefeb";
		}
		elseif ($ratio < 0.65 )
			{
			$color ="#fff5d5";
			}
		elseif ($ratio < 0.8 )
			{
			$color="#f6ffc5";
			}
		elseif ($ratio < 0.95 )
			{
			$color="#d5ffff";
			}
		else
			{
			$color="#d8ffd5";
			}
return $color;
}


/* ip validation */
function validip($ip)
{
	if (!empty($ip) && ip2long($ip)!=-1)
	{
		$reserved_ips = array (
				array('0.0.0.0','2.255.255.255'),
				array('10.0.0.0','10.255.255.255'),
				array('127.0.0.0','127.255.255.255'),
				array('169.254.0.0','169.254.255.255'),
				array('172.16.0.0','172.31.255.255'),
				array('192.0.2.0','192.0.2.255'),
				array('192.168.0.0','192.168.255.255'),
				array('255.255.255.0','255.255.255.255')
		);

		foreach ($reserved_ips as $r)
		{
				$min = ip2long($r[0]);
				$max = ip2long($r[1]);
				if ((ip2long($ip) >= $min) && (ip2long($ip) <= $max)) return false;
		}
		return true;
	}
	else return false;
}

/* get real ip - Special Thanks to Visigod for his contribution*/
function getip()
{
   if (getenv("HTTP_CLIENT_IP") && strcasecmp(getenv("HTTP_CLIENT_IP"), "unknown"))
           $ip = getenv("HTTP_CLIENT_IP");
       else if (getenv("HTTP_X_FORWARDED_FOR") && strcasecmp(getenv("HTTP_X_FORWARDED_FOR"), "unknown"))
           $ip = getenv("HTTP_X_FORWARDED_FOR");
       else if (getenv("REMOTE_ADDR") && strcasecmp(getenv("REMOTE_ADDR"), "unknown"))
           $ip = getenv("REMOTE_ADDR");
       else if (isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], "unknown"))
           $ip = $_SERVER['REMOTE_ADDR'];
       else
           $ip = "unknown";
   return($ip);
}

/* page stats */
function tt_stats($cached)
	{
	global $timer, $db, $gzip_enabled, $dbprfx;
	$timer->stop_timer();
	if (!$cached)
		{
		$cached = 'NO';
		}
		else
		{
		$cached = 'YES';
		}
    if ($_SESSION['logged_in'] == true)
    	{
    	$loggedin = "YES";
    	}
    	else
    	{
    	$loggedin = "NO";
    	}
    $online = $db->count_rows("SELECT *  FROM ".$dbprfx."members WHERE (NOW() - lastvisit) < 1200");
    $output = '<b>Powered by <a href="http://www.torrenttrader.com" target="_blank" alt="Torrent Trader v2.0 RC1">Torrent Trader v2.0 RC1</a> by Sqrtboy</b><br>';
	$output .= '[ logged in: '.$loggedin.' ]&nbsp;&nbsp;';
	$output .= '[ members online: '.$online.' ]&nbsp;&nbsp;';
	$output .= '[ queries used: ' . $db->count_queries() . ' ]&nbsp;&nbsp;';
	$output .= '[ execution time: ' . $timer->display_time() . ' ]&nbsp;&nbsp;';
	$output .= '[ affected rows: ' . $db->affected_rows() . ' ]&nbsp;&nbsp;';
	$output .= '[ gzip: ' . $gzip_enabled . ' ]&nbsp;&nbsp;';
	$output .= '[ cached: ' . $cached . ' ]';

	$output .= "<br>" . @trim(exec('uptime')) . "";
	$output .= "<center><table border=1 width=100 height=12><tr><td style='padding: 0px; background-image: url(images/loadbarbg.gif); background-repeat: repeat-x'>";

 	$percent = $timer->execution_time * 30;

    if ($percent <= 70) $pic = "loadbargreen.gif";
     elseif ($percent <= 90) $pic = "loadbaryellow.gif";
      else $pic = "loadbarred.gif";
           $width = $percent * 4;
	$output .= "<img height=15 border=0 width=$width src=\"images/$pic\" alt='$percent%'></td></tr></table></center>";

 	return $output;
    }

/* caches a page */
function tt_cache($length, $status)
	{
	global $cache_template;
	$tpl = new torrenttrader_template();
	$tpl->setCacheDir($cache_template);
	$tpl->setCacheLifetime($length);
	if($status == 'yes')
		{
		$tpl->setCaching(true);
		}
		else
		{
		$tpl->setCaching(false);
		}
	}

/* page header */
function tt_template_start($navbar = '')
	{
	global $tt_theme, $CURUSER;
	$tpl = new torrenttrader_template();
    $tpl->addVar('tt_theme', $tt_theme);
	$tpl->addVar('displaysettings', tt_display_settings());
	$tpl->addVar('username', $CURUSER['username']);
	$tpl->addVar('navigation', '<a href="index.php">Home</a> > '.$navbar.'');
    $tpl->addVar('displaystats', tt_display_stats() );
	$tpl->display('theme/' . $tt_theme . '/templates/main_header.tpl');
	}

/* page footer */
function tt_template_end($pageid = '')
	{
	global $tt_theme, $CURUSER;
	$tpl = new torrenttrader_template();
    $tpl->addVar('tt_theme', $tt_theme);
	$tpl->addVar('pagestats', tt_stats($tpl->isCached($pageid)));
	$tpl->display('theme/' . $tt_theme . '/templates/main_footer.tpl');
	}

/* prints success/error message */
function tt_warning($heading, $msg, $type)
	{
	global $tt_theme;
	$tpl = new torrenttrader_template();
	$tpl->addVar('heading', $heading);
	$tpl->addVar('text', $msg);
	$tpl->display('theme/' . $tt_theme . '/templates/warning_'.$type.'.tpl');
	}

/* force user to login */
function tt_members_only()
	{
    global $tt_theme;
    	if (  $_SESSION['logged_in'] == false )
        	{
            tt_template_start('Login');
			tt_warning('MEMBERS ONLY', 'Please login to continue.', 'error');
            $tpl = new torrenttrader_template();
            $tpl->display('theme/' . $tt_theme . '/templates/user_login.tpl');
            tt_template_end();
            die();
   	        }
	}

/* prints a list of all usergroups a member is in */
function tt_show_groups()
	{
    global $db, $dbprfx, $CURUSER;
    $res = "";
    $group_array = explode(":", $CURUSER['groups']);
    $result = $db->query("SELECT * FROM ".$dbprfx."groups ORDER BY id DESC");
  	while ($row = $db->fetch_array($result))
	    {
	    if (in_array($row["id"],$group_array) )
	   		{
	    	$res .= $row["name"] . ": <font color=green><b>YES</b></font><br>" ;
			}
	    	else
	    	{
	    	$res .= $row["name"] . ": <font color=red><b>NO</b></font><br>" ;
			}
	    }
	return $res;
	}

/* check if one users belongs to a group or not */
function is_in_group($groups,$groupname)
	{
    global $db, $dbprfx;
    $res = "";
    $group_array = explode(":", $groups);
    $row = $db->fetch_row("SELECT id FROM ".$dbprfx."groups WHERE name='".$groupname."' LIMIT 1");
	    if (in_array($row["id"],$group_array) )
     	return true;
        else return false ;

	}

/* torrent color */
function color_group($groups)
{
global $db, $dbprfx;
    $group_array = explode(":", $groups);
    $result = $db->query("SELECT * FROM ".$dbprfx."groups ORDER BY id DESC");
  	while ($row = $db->fetch_array($result))
	    {
	    if (in_array($row["id"],$group_array) )
        return $row["color"];
        }
	return "black";

}


/* returns username from id */
function tt_get_username($id)
	{
	global $db, $dbprfx;
  	$result = $db->query("SELECT * FROM ".$dbprfx."members WHERE id='$id'");
  	$numrows = $db->num_rows($result);
  	$row = $db->fetch_array($result);
	return ($row["username"]);
	}

/* returns id from username */
function tt_get_id($username)
	{
	global $db, $dbprfx;
  	$result = $db->query("SELECT * FROM ".$dbprfx."members WHERE username = '$username'");
  	$numrows = $db->num_rows($result);
  	$row = $db->fetch_array($result);
	return ($row["id"]);
	}

/* returns category from id */
function tt_get_category($id)
	{
	global $db, $dbprfx;
  	$result = $db->query("SELECT * FROM ".$dbprfx."categories WHERE id='$id'");
  	$numrows = $db->num_rows($result);
  	$row = $db->fetch_array($result);
	return ($row["name"]);
	}

/* display settings */
function tt_display_settings()
	{
	global $db, $dbprfx,$CURUSER;
	
	$perpage25 = "";
	$perpage50 = "";
	$perpage75 = "";
	$perpage100 = "";

    switch ($CURUSER['perpage'])
    {
    case 25:
    	$perpage25 = "selected=\"selected\"";
        break;
    case 50:
    	$perpage50 = "selected=\"selected\"";
        break;
    case 75:
     	$perpage75 = "selected=\"selected\"";
        break;
    case 100:
    	$perpage100 = "selected=\"selected\"";
        break;
    default:
    	$perpage25 = "selected=\"selected\"";
        break;
    }
  	/* change theme */
  	$result  = $db->query("SELECT * FROM ".$dbprfx."themes");
  	$output  = '<b>Theme:</b><br /><form name="jump1"><select name="switchtheme" size="1" style="width:136px;" onChange="location=document.jump1.switchtheme.options[document.jump1.switchtheme.selectedIndex].value;">';
	while ($row = $db->fetch_array($result))
		{
		$switchtheme[] = array(
		'id' => $row['id'],
		'name' => $row['name']);
		}
	foreach ($switchtheme as $a)
		{
        if ($CURUSER['theme'] == $a['id'])
		$output .= '<option value="index.php?theme='.$a["id"].'" selected="selected">&nbsp;->&nbsp;'.$a["name"].'</option>';
        else
		$output .= '<option value="index.php?theme='.$a["id"].'">&nbsp;->&nbsp;'.$a["name"].'</option>';
		}

	$output .= '</select></form><div class="seperator"></div><b>Torrents Per Page:</b><br />';

	/* change torrents per page */
	$output .= '<form name="jump2"><select name="switchperpage" size="1" style="width:136px;" onChange="location=document.jump2.switchperpage.options[document.jump2.switchperpage.selectedIndex].value;">';
	$output .= '<option value="index.php?perpage=25" '.$perpage25.'>&nbsp;->&nbsp;25</option>';
	$output .= '<option value="index.php?perpage=50" '.$perpage50.'>&nbsp;->&nbsp;50</option>';
	$output .= '<option value="index.php?perpage=75" '.$perpage75.'>&nbsp;->&nbsp;75</option>';
	$output .= '<option value="index.php?perpage=100" '.$perpage100.'>&nbsp;->&nbsp;100</option>';
	$output .= '</select></form>';
	return $output;
	}


/* display tracker stats */
function tt_display_stats()
	{
	global $db, $dbprfx;
  	/* change theme */
    $num = $db->count_rows("SELECT id FROM ".$dbprfx."members WHERE status='confirmed'");
  	$output  = '<b>Members:</b><br />';
    $output .= $num.' confirmed<br>';
 	$num = $db->count_rows("SELECT id FROM ".$dbprfx."members WHERE status='pending'");
    $output .= $num.' pending<br>';

    $output .= '<div class="seperator"></div>';
    $output .= '<b>Torrents:</b><br />';
 	$num = $db->count_rows("SELECT id FROM ".$dbprfx."torrents ");
    $output .= $num.' torrents<br>';
 	$num = $db->count_rows("SELECT id FROM ".$dbprfx."torrents_files ");
    $output .= $num.' files<br>';

	$output .= '<div class="seperator"></div>';

    $output .= '<b>Peers:</b><br />';
 	$num1 = $db->count_rows("SELECT * FROM ".$dbprfx."torrents_peers ");
    $output .= $num1.' peers<br>';
 	$num2 = $db->count_rows("SELECT * FROM ".$dbprfx."torrents_peers WHERE seeder='yes'");
    $output .= $num2.' seeders<br>';
    $output .= ($num1-$num2).' leechers<br>';

	return $output;
	}

/* get filesize  */
function tt_filesize($bytes)
	{
	if ($bytes < 1000 * 1024)
		return number_format($bytes / 1024, 2) . " kB";
	elseif ($bytes < 1000 * 1048576)
		return number_format($bytes / 1048576, 2) . " MB";
	elseif ($bytes < 1000 * 1073741824)
		return number_format($bytes / 1073741824, 2) . " GB";
	else
		return number_format($bytes / 1099511627776, 2) . " TB";
	}

/* shorten string */
function tt_shorten( $str, $length = 60 )
	{
	if( $length < 3 ) return $str;
	else if( strlen( $str ) <= $length) return $str;
	else return substr( $str, 0, ($length-3) ) . "...";
	}

/* add text (i.e. comments/news/pm) to the database */
function tt_add_text($character_limit, $action, $submit_name, $button_text, $item_id, $re, $text, $to = "", $subject = "")
	{
	global $bbcode, $tt_theme;
	$tpl = new torrenttrader_template();
   	if($to)
   		{
   		$tpl->addVar('to', 'yes');
   		}
   	if($subject)
   		{
   		$tpl->addVar('subject', 'yes');
   		}
   	$tpl->addVar('toolbar', $bbcode->show_toolbar('form', 'comment'));
   	$tpl->addVar('smilies', $bbcode->show_smilies('form', 'comment'));
   	$tpl->addVar('text', $text);
   	$tpl->addVar('re', $re);
    $tpl->addVar('item_id', $item_id);
    $tpl->addVar('submit_name', $submit_name);
    $tpl->addVar('action', $action);
    $tpl->addVar('character_limit', $character_limit);
    $tpl->addVar('button_text', $button_text);
	$tpl->addVar('subject', $subject);
	$tpl->addVar('to', $to);
	$tpl->display('theme/' . $tt_theme . '/templates/main_addtext.tpl');
	}

/* all functions in the bencoding/bdecoding class */

function benc($obj) {
	if (!is_array($obj) || !isset($obj["type"]) || !isset($obj["value"]))
		return;
	$c = $obj["value"];
	switch ($obj["type"]) {
		case "string":
			return benc_str($c);
		case "integer":
			return benc_int($c);
		case "list":
			return benc_list($c);
		case "dictionary":
			return benc_dict($c);
		default:
			return;
	}
}

function benc_str($s) {
	return strlen($s) . ":$s";
}

function benc_int($i) {
	return "i" . $i . "e";
}

function benc_list($a) {
	$s = "l";
	foreach ($a as $e) {
		$s .= benc($e);
	}
	$s .= "e";
	return $s;
}

function benc_dict($d) {
	$s = "d";
	$keys = array_keys($d);
	sort($keys);
	foreach ($keys as $k) {
		$v = $d[$k];
		$s .= benc_str($k);
		$s .= benc($v);
	}
	$s .= "e";
	return $s;
}


function bdec_file($f, $ms) {
	$fp = fopen($f, "rb");
	if (!$fp)
		return;
	$e = fread($fp, $ms);
	fclose($fp);
	return bdec($e);
}

function bdec($s) {
	if (preg_match('/^(\d+):/', $s, $m)) {
		$l = $m[1];
		$pl = strlen($l) + 1;
		$v = substr($s, $pl, $l);
		$ss = substr($s, 0, $pl + $l);
		if (strlen($v) != $l)
			return;
		return array("type" => "string", "value" => $v, "strlen" => strlen($ss), "string" => $ss);
	}
	if (preg_match('/^i(\d+)e/', $s, $m)) {
		$v = $m[1];
		$ss = "i" . $v . "e";
		if ($v === "-0")
			return;
		if ($v[0] == "0" && strlen($v) != 1)
			return;
		return array("type" => "integer", "value" => $v, "strlen" => strlen($ss), "string" => $ss);
	}
	switch ($s[0]) {
		case "l":
			return bdec_list($s);
		case "d":
			return bdec_dict($s);
		default:
			return;
	}
}

function bdec_list($s) {
	if ($s[0] != "l")
		return;
	$sl = strlen($s);
	$i = 1;
	$v = array();
	$ss = "l";
	for (;;) {
		if ($i >= $sl)
			return;
		if ($s[$i] == "e")
			break;
		$ret = bdec(substr($s, $i));
		if (!isset($ret) || !is_array($ret))
			return;
		$v[] = $ret;
		$i += $ret["strlen"];
		$ss .= $ret["string"];
	}
	$ss .= "e";
	return array("type" => "list", "value" => $v, "strlen" => strlen($ss), "string" => $ss);
}

function bdec_dict($s) {
	if ($s[0] != "d")
		return;
	$sl = strlen($s);
	$i = 1;
	$v = array();
	$ss = "d";
	for (;;) {
		if ($i >= $sl)
			return;
		if ($s[$i] == "e")
			break;
		$ret = bdec(substr($s, $i));
		if (!isset($ret) || !is_array($ret) || $ret["type"] != "string")
			return;
		$k = $ret["value"];
		$i += $ret["strlen"];
		$ss .= $ret["string"];
		if ($i >= $sl)
			return;
		$ret = bdec(substr($s, $i));
		if (!isset($ret) || !is_array($ret))
			return;
		$v[$k] = $ret;
		$i += $ret["strlen"];
		$ss .= $ret["string"];
	}
	$ss .= "e";
	return array("type" => "dictionary", "value" => $v, "strlen" => strlen($ss), "string" => $ss);
}

function deadtime() {
    global $announce_interval;
    return time() - floor($announce_interval * 1.3);
}

function tt_cleanup() {
	global $db, $dbprfx, $signup_timeout, $max_dead_torrent_time, $torrent_dir;

	set_time_limit(0);
	ignore_user_abort(1);

	do {
		$res = $db->query("SELECT id FROM ".$dbprfx."torrents");
		$ar = array();
		while ($row = $db->fetch_array($res)) {
			$id = $row[0];
			$ar[$id] = 1;
		}

		if (!count($ar))
			break;

		$dp = @opendir($torrent_dir);
		if (!$dp)
			break;

		$ar2 = array();
		while (($file = readdir($dp)) !== false) {
			if (!preg_match('/^(\d+)\.torrent$/', $file, $m))
				continue;
			$id = $m[1];
			$ar2[$id] = 1;
			if (isset($ar[$id]) && $ar[$id])
				continue;
			$ff = $torrent_dir . "/$file";
			unlink($ff);
		}
		closedir($dp);

		if (!count($ar2))
			break;

		$delids = array();
		foreach (array_keys($ar) as $k) {
			if (isset($ar2[$k]) && $ar2[$k])
				continue;
			$delids[] = $k;
			//unset($ar[$k]);
		}
		
		if (count($delids))
			{
			$db->query("DELETE FROM ".$dbprfx."torrents WHERE id IN (" . join(",", $delids) . ")");
			$db->query("DELETE FROM ".$dbprfx."torrents_peers WHERE torrent IN (" . join(",", $delids) . ")");
			$db->query("DELETE FROM ".$dbprfx."torrents_files WHERE torrent IN (" . join(",", $delids) . ")");
			}
			
	} while (0);

	$deadtime = deadtime();
	$db->query("DELETE FROM ".$dbprfx."torrents_peers WHERE last_action < FROM_UNIXTIME($deadtime)");

	$deadtime -= $max_dead_torrent_time;
	$db->query("UPDATE ".$dbprfx."torrents SET visible='no' WHERE visible='yes' AND last_action < FROM_UNIXTIME($deadtime)");

	$deadtime = time() - $signup_timeout;
	$db->query("DELETE FROM ".$dbprfx."members WHERE status = 'pending' AND added < FROM_UNIXTIME($deadtime) AND lastvisit < FROM_UNIXTIME($deadtime)");

	$res = $db->query("SELECT id FROM ".$dbprfx."torrents");
	while ($torrent = $db->fetch_array($res)) {
	$res1 = $db->query("SELECT COUNT(*) AS c FROM ".$dbprfx."torrents_peers WHERE torrent= ".$torrent["id"]." AND seeder='yes'");
	$row1= $db->fetch_array($res1) ;
	$res2 = $db->query("SELECT COUNT(*) AS c FROM ".$dbprfx."torrents_peers WHERE torrent= ".$torrent["id"]." AND seeder='no'");
	$row2= $db->fetch_array($res2) ;
	$db->query("UPDATE ".$dbprfx."torrents SET  seeders=".$row1["c"]." , leechers = ".$row2["c"]." WHERE id = ".$torrent["id"]."");			
	}


}



require_once('classes/class.debug.php');
?>